//#define XERR
#include "loop.ih"

void Loop::initialize(size_t idx)
{
    d_caseCost = 0;                         // org: womenCosts
    d_deathAge = 0;                         // org: tumorDeathAge
    d_roundDetected = 0;                    // org: roundDetected
    d_selfDetected = false;                 // org: selfDetected

                                // Breast density indices to use for the
                                // ages of the screening rounds
    d_indices = d_densities.indices(d_screening.ages());

    d_tumorInfo.cumTotalRisk(
                    d_screening.radiationRisk(
                            d_modalities,
                            d_indices,
                            d_tumorInfo.beir7().beta(), 
                            d_tumorInfo.beir7().eta()
                    )
                );

    Options::instance().naturalDeathAge(
                                    d_naturalDeathAge = naturalDeathAge());
    d_status = PRESENT;

    d_tumor.reset();
}






